//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x, y, typ]=ARDUINO_DIGITAL_WRITE(job, arg1, arg2)
    x=[];
    y=[];
    typ=[];
    style = "ARDUINO_DIGITAL_WRITE;blockWithLabel;"+..
            "verticalLabelPosition=bottom;verticalAlign=top;spacing=-2;align=center;"+..
            "displayedLabel=Digital WRITE<br>Pin %s on board %s"
    select job
    case 'plot' then
        // deprecated
    case 'getinputs' then
        // deprecated
    case 'getoutputs' then
        // deprecated
    case 'getorigin' then
        // deprecated
    case 'set' then
        x=arg1;
        graphics=arg1.graphics;
        exprs=graphics.exprs
        model=arg1.model;

        while %t do
            [ok,num_pin,num_arduino,exprs]=scicos_getvalue(['Arduino Digital Write parameters' ; 'UNO digital PIN are : 0 to 13.'; 'MEGA digital PIN are : 0 to 53.'],..
            [gettext('Digital Pin'),gettext('Arduino board number')],list('vec',1,'vec',1), exprs)
            mess=[];

            if ~ok then// Cancel
                break;
            end
            if num_arduino<>1 then
                mess=[mess ;gettext("Only board 1 can be used with this toolbox version ")];
                ok=%f;
            end
            if num_pin < 2 | num_pin>53
                mess=[mess ;_("Digital Pin must be between 2 and 53.")]
                ok = %f
            end


            if ok then// Everything's ok
                model.rpar=[num_pin,num_arduino];
                graphics.exprs = exprs;
                x.model=model;
                x.graphics = graphics;
                x.graphics.style = msprintf(style, exprs');
                break
            else
                message(mess);
            end

        end
    case 'define' then
        model=scicos_model();
        model.sim=list("ARDUINO_DIG_WRITE_sim", 5)
        model.blocktype='d';
        model.dep_ut=[%f %f];
        model.in=[1];
        model.evtin=[1];
        model.evtout=[1];
        model.firing=[0;-1]
        Pin=13;
        num_arduino=1;
        model.rpar=[Pin,num_arduino]; //Default Pin number and Arduino board number
        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=['E'];
        tmp = string([Pin, num_arduino])
        x.graphics.style = msprintf(style, tmp)
        x.graphics.exprs = tmp;
    end
endfunction
